Bug 837502 (CVE-2012-3375)

Summary: CVE-2012-3375 kernel: epoll: can leak file descriptors when returning -ELOOP
Product: [Other] Security Response Reporter: Petr Matousek <pmatouse>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: agordeev, anton, bhu, davej, dhoward, djorm, fhrbata, gansalmon, itamar, jforbes, jkacur, jonathan, jwboyer, kernel-maint, kernel-mgr, lgoncalv, lwang, madhu.chinakonda, mjc, plougher, rt-maint, sforsber, williams
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=moderate,public=20120327,reported=20120427,source=redhat,cvss2=4.9/AV:L/AC:L/Au:N/C:N/I:N/A:C,rhel-5/kernel=affected,rhel-6/kernel=notaffected,rhel-6.2.z/kernel=affected,fedora-all/kernel=affected,mrg-2/realtime-kernel=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-08-24 09:53:16 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 817131, 817140, 829670, 837503, 837504, 837505, 837506, 837507, 837509    
Bug Blocks: 717854    

Description Petr Matousek 2012-07-04 03:09:04 EDT
An epoll_ctl(,EPOLL_CTL_ADD,,) operation can return '-ELOOP' to prevent circular epoll dependencies from being created.  However, in that case we do not properly clear the 'tfile_check_list'.

An unprivileged local user could use this flaw to crash the system.

This is a regression introduced via the CVE-2011-1083 (bug #681578) fix (commit 28d82dc1c4edbc352129f97f4ca22624d1fe61de):
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=28d82dc1c4edbc352129f97f4ca22624d1fe61de

Upstream fix:
13d518074a952d33d47c428419693f63389547e9
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=13d518074a952d33d47c428419693f63389547e9

References:
https://lkml.org/lkml/2012/3/27/65
https://lkml.org/lkml/2012/4/17/247
Comment 3 Petr Matousek 2012-07-04 03:13:01 EDT
Created kernel tracking bugs for this issue

Affects: fedora-all [bug 837506]
Comment 5 Vincent Danen 2012-07-04 13:14:33 EDT
Assigned CVE-2012-3375 as per:

http://www.openwall.com/lists/oss-security/2012/07/04/2
Comment 6 Petr Matousek 2012-07-06 14:10:33 EDT
Statement:

This issue did not affect the versions of the Linux kernel as shipped with Red Hat Enterprise Linux 6, since updates fixing CVE-2011-1083 contained a corrected patch that did not introduce this regression. 

This has been addressed in Red Hat Enterprise Linux 5 via https://rhn.redhat.com/errata/RHSA-2012-1061.html, and Red Hat Enterprise Linux Red Hat Enterprise MRG 2 via https://rhn.redhat.com/errata/RHSA-2012-1150.html
Comment 7 errata-xmlrpc 2012-07-10 07:35:14 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2012:1061 https://rhn.redhat.com/errata/RHSA-2012-1061.html
Comment 8 errata-xmlrpc 2012-08-08 12:35:26 EDT
This issue has been addressed in following products:

  MRG for RHEL-6 v.2

Via RHSA-2012:1150 https://rhn.redhat.com/errata/RHSA-2012-1150.html